import pygame
from pygame.locals import *
import save_file_dialog, line_width_dialog
import choose_color_dialog, drawing_style_dialog
import menus
import time

pygame.init()

screen = pygame.display.set_mode((640,480))
temp_screen = pygame.Surface((640,480))
temp_screen.fill((0,0,0))

clock = pygame.time.Clock()
line_color = (255,255,255)
rubberband_drawing = True
freehand_drawing = False
drawing = False
line_width = 5

run = True
start_pos = (0,0)
end_pos = (0,0)

menu_names = ['Save drawing',
                'Line color',
                'Line width',
                'Freehand',
                'Rubberband']

menus.do_menu(screen, menu_names)


while run:

    clock.tick(50)
    fps = clock.get_fps()

    for event in pygame.event.get():
        if event.type == QUIT:
            run = False

        if event.type == MOUSEMOTION:
            if rubberband_drawing and drawing:
                rect = pygame.draw.line(screen, (0,0,0), start_pos, end_pos, line_width)
                current_pos = event.pos
                screen.blit(temp_screen, temp_screen.get_rect())
                pygame.draw.line(screen, line_color, start_pos, current_pos, 1)
                end_pos = current_pos

            elif freehand_drawing and drawing:
                current_pos = event.pos
                movement = event.rel
                old_pos = (current_pos[0]-movement[0], current_pos[1]-movement[1])
                pygame.draw.line(screen, line_color, old_pos, current_pos, line_width)

        if event.type == MOUSEBUTTONUP:
            if event.button == 1:
                if rubberband_drawing and drawing:
                    screen.blit(temp_screen, temp_screen.get_rect())
                    current_pos = event.pos
                    pygame.draw.line(screen, line_color, start_pos, current_pos, line_width)
                drawing = False

        if event.type == MOUSEBUTTONDOWN:
            if event.button == 1:
                pos = event.pos
                menu = menus.get_menu(pos)
                if not menu:
                    if rubberband_drawing:
                        if not drawing:
                            temp_screen.blit(screen, screen.get_rect())
                            start_pos = event.pos
                            drawing = True
                    elif freehand_drawing:
                        if drawing:
                            current_pos = event.pos
                            pygame.draw.line(screen, line_color, start_pos, current_pos, line_width)
                            start_pos = current_pos
                        else:
                            drawing = True
                            start_pos = event.pos

                else:
                    if menu == 'Line color':
                        color = choose_color_dialog.show_color_dialog()
                        if color:
                            line_color = color
                    elif menu == 'Save drawing':
                        path = save_file_dialog.show_save_dialog()
                        if path:
                            pygame.image.save(screen, path)
                    elif menu == 'Line width':
                        width = line_width_dialog.show_line_width_dialog()
                        if width:
                            line_width = int(width)
                    elif menu == 'Rubberband':
                        rubberband_drawing = True
                        freehand_drawing = False
                    elif menu == 'Freehand':
                        rubberband_drawing = False
                        freehand_drawing = True

            if event.button == 3:
                width = line_width_dialog.show_line_width_dialog()
                if width:
                    line_width = int(width)

    pygame.display.set_caption('fps = ' + str(fps))
    pygame.display.flip()


